c3
      SUBROUTINE PRECDEC(I,NS,T,H,NY,NU,NV,Y,NM,GAMMA,
     &                   KDFYM,LDFYM,LDFY,DFY,LDEV,DEV,
     &                   BHI,IBHI,IER,RPAR,IPAR)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: I
      INTEGER, INTENT(IN   ) :: NS
      REAL   , INTENT(IN   ) :: T
      REAL   , INTENT(IN   ) :: H
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      INTEGER, INTENT(IN   ) :: NM
      REAL   , INTENT(IN   ) :: GAMMA(NS,NM)
      INTEGER, INTENT(IN   ) :: KDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFY
      REAL   , INTENT(IN   ) :: DFY(NY,NY,NM)
      INTEGER, INTENT(IN   ) :: LDEV
      INTEGER, INTENT(IN   ) :: DEV(NV,NV)
      REAL   , INTENT(  OUT) :: BHI(NY,NY)
      INTEGER, INTENT(  OUT) :: IBHI(NY)
      INTEGER, INTENT(  OUT) :: IER
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: J,M,NY2
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE PRECDEC
C-----------------------------------------------------------------------
C------- SET THE BLOCK H_i -----
      NY2=NY*NY
c      BHI=0.0
      CALL DSCAL(NY2,0.0,BHI(1,1),1)
      DO J=1,NU
         BHI(J,J)=1.0
      ENDDO
      DO J=1,NV
         CALL DCOPY(NV,DEV(1,J),1,BHI(NU+1,NU+J),1)
      ENDDO
C--------- Fmy PART -----
      DO M=1,NM
         CALL DAXPY(NY2,-H*GAMMA(I,M),DFY(1,1,M),1,BHI(1,1),1)
      ENDDO
      CALL DGETRF(NY,NY,BHI,NY,IBHI,IER)
      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE PRECDEC
C-----------------------------------------------------------------------
c3end
