      SUBROUTINE DEVVECSP(T,NY,NU,NV,Y,ECN,DEVVECCN,IDEVVECCN,
     &                    DELTV,VPTR,TMPNY,E0,
     &                    LDEV,DEV,VEC,DEVVEC,RPAR,IPAR)
C-----------------------------------------------------------------------
C     PERFORM THE FOLLOWING MATRIX-VECTOR PRODUCT
C     DEVVEC <-- e_v*VEC
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  ECN
      EXTERNAL                  DEVVECCN
      INTEGER, INTENT(IN   ) :: IDEVVECCN
      REAL   , INTENT(IN   ) :: DELTV
      INTEGER, INTENT(IN   ) :: VPTR
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(IN   ) :: E0(NV)
      INTEGER, INTENT(IN   ) :: LDEV
      REAL   , INTENT(IN   ) :: DEV(LDEV)
      REAL   , INTENT(IN   ) :: VEC(NV)
      REAL   , INTENT(  OUT) :: DEVVEC(NV)
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DEVVECSP
C-----------------------------------------------------------------------
      IF     (IDEVVECCN==0) THEN
         CALL DGEMV('N',NV,NV,1.0,DEV,NV,VEC,1,0.0,DEVVEC,1)
      ELSEIF (IDEVVECCN==1) THEN
         CALL DEVVECFD(T,NY,NU,NV,Y,ECN,DELTV,VPTR,TMPNY,E0,
     &                                       VEC,DEVVEC,RPAR,IPAR)
      ELSEIF (IDEVVECCN==2) THEN
         CALL DEVVECCN(T,NY,NU,NV,Y,LDEV,DEV,VEC,DEVVEC,RPAR,IPAR)
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DEVVECSP
C-----------------------------------------------------------------------
