      SUBROUTINE DFYVECSPM(M,T,NY,NU,NV,Y,FCNM,DFYVECCNM,IDFMYVECCN,
     &                     DELTY,TMPNY,FM0,
     &                     LDFMY,DFMY,VEC,DFMYVEC,RPAR,IPAR)
C-----------------------------------------------------------------------
C     PERFORM THE FOLLOWING MATRIX-VECTOR PRODUCT
C     DFMYVEC <-- f_{my}*VEC
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: M
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  FCNM
      EXTERNAL                  DFYVECCNM
      INTEGER, INTENT(IN   ) :: IDFMYVECCN
      REAL   , INTENT(IN   ) :: DELTY
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(IN   ) :: FM0(NY)
      INTEGER, INTENT(IN   ) :: LDFMY
      REAL   , INTENT(IN   ) :: DFMY(LDFMY)
      REAL   , INTENT(IN   ) :: VEC(NY)
      REAL   , INTENT(  OUT) :: DFMYVEC(NY)
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DFYVECSPM
C-----------------------------------------------------------------------
      IF     (IDFMYVECCN==0) THEN
         CALL DGEMV('N',NY,NY,1.0,DFMY,NY,VEC,1,0.0,DFMYVEC,1)
      ELSEIF (IDFMYVECCN==1) THEN
         CALL DFYVECFDM(M,T,NY,NU,NV,Y,FCNM,DELTY,TMPNY,FM0,
     &                                            VEC,DFMYVEC,RPAR,IPAR)
      ELSEIF (IDFMYVECCN==2) THEN
         CALL DFYVECCNM(M,T,NY,NU,NV,Y,LDFMY,DFMY,VEC,DFMYVEC,RPAR,IPAR)
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DFYVECSPM
C-----------------------------------------------------------------------
