      SUBROUTINE DIAGVEC(NY,DIAG,VECX,VECY,INCVEC,INVERSE)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NY
      REAL   , INTENT(IN   ) :: DIAG(NY)
      REAL   , INTENT(IN   ) :: VECX(NY)
      REAL   , INTENT(  OUT) :: VECY(NY)
      INTEGER, INTENT(IN   ) :: INCVEC
      LOGICAL, INTENT(IN   ) :: INVERSE
C    LOCAL VARIABLES
      INTEGER                :: I
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DIAGVEC
C-----------------------------------------------------------------------
      IF (.NOT.(INVERSE)) THEN
         DO I=1,NY,INCVEC
            VECY(I)=VECX(I)*DIAG(I)
         ENDDO      
      ELSE
         DO I=1,NY,INCVEC
            VECY(I)=VECX(I)/DIAG(I)
         ENDDO      
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DIAGVEC
C-----------------------------------------------------------------------
