      SUBROUTINE EFISM(NM,NY,NU,NV,LNV,NVGE1,Y,FCNM,ECN,
     &                     RPAR,TPCISH,IPAR,ZYIS,
     &                     TMPNY,FIS,EIS)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      INTEGER, INTENT(IN   ) :: LNV
      LOGICAL, INTENT(IN   ) :: NVGE1
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  FCNM
      EXTERNAL                  ECN
      REAL   , INTENT(IN   ) :: RPAR(*)
      REAL   , INTENT(IN   ) :: TPCISH
      INTEGER, INTENT(IN   ) :: IPAR(*)
      REAL   , INTENT(IN   ) :: ZYIS(NY)
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(  OUT) :: FIS(NY,NM)
      REAL   , INTENT(  OUT) :: EIS(LNV)
C    LOCAL VARIABLES
      INTEGER                :: M
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE EFISM
C-----------------------------------------------------------------------
c      TMPNY=Y+ZYIS
      CALL DCOPY(NY    , Y  ,1,TMPNY,1)
      CALL DAXPY(NY,1.0,ZYIS,1,TMPNY,1)
      DO M=1,NM
         CALL FCNM(M,TPCISH,NY,NU,NV,TMPNY,FIS(1,M),RPAR,IPAR)
      ENDDO
      IF (NVGE1) THEN
         CALL  ECN(  TPCISH,NY,NU,NV,TMPNY,EIS     ,RPAR,IPAR)
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE EFISM
C-----------------------------------------------------------------------
