      SUBROUTINE ENSP1(NY,NU,NV,LNV,Y,ECN,
     &                     RPAR,TPH,IPAR,ZNY,
     &                     TMPNY,EN)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      INTEGER, INTENT(IN   ) :: LNV
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  ECN
      REAL   , INTENT(IN   ) :: RPAR(*)
      REAL   , INTENT(IN   ) :: TPH
      INTEGER, INTENT(IN   ) :: IPAR(*)
      REAL   , INTENT(IN   ) :: ZNY(NY)
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(  OUT) :: EN(LNV)
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE ENSP1
C-----------------------------------------------------------------------
c      TMPNY=Y+ZNY
      CALL DCOPY(NY    ,  Y,1,TMPNY,1)
      CALL DAXPY(NY,1.0,ZNY,1,TMPNY,1)
      CALL ECN(TPH  ,NY,NU,NV ,TMPNY   ,EN,RPAR,IPAR)

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE ENSP1
C-----------------------------------------------------------------------
