      SUBROUTINE DFYVECCNM(M,T,NY,NU,NV,Y,LDFMY,DFMY,VEC,DFMYVEC,
     &                     RPAR,IPAR)
C-----------------------------------------------------------------------
C     ONLY THE NONZERO ELEMENTS OF DFMYVEC NEED TO BE SET
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: M
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      INTEGER, INTENT(IN   ) :: LDFMY
      REAL   , INTENT(IN   ) :: DFMY(5,NY)
      REAL   , INTENT(IN   ) :: VEC(NY)
      REAL   , INTENT(  OUT) :: DFMYVEC(NY)
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: KL,KU
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DFYVECCNM
C-----------------------------------------------------------------------
      KL=IPAR(3)
      KU=IPAR(4)
       IF (M==1) THEN
      CALL DGBMV('N',NY,NY,KL,KU,1.0,DFMY,5,VEC,1,0.0,DFMYVEC,1)
       ENDIF
      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DFYVECCNM
C-----------------------------------------------------------------------


