      SUBROUTINE PRECDEC(I,NS,T,H,NY,NU,NV,Y,NM,GAMMA,
     &                   KDFYM,LDFYM,LDFY,DFY,LDEV,DEV,
     &                   BHI,IBHI,IER,RPAR,IPAR)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: I
      INTEGER, INTENT(IN   ) :: NS
      REAL   , INTENT(IN   ) :: T
      REAL   , INTENT(IN   ) :: H
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      INTEGER, INTENT(IN   ) :: NM
      REAL   , INTENT(IN   ) :: GAMMA(NS,NM)
      INTEGER, INTENT(IN   ) :: KDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFY
      REAL   , INTENT(IN   ) :: DFY(5,NY)   ! DFY(5,NY,NM)
      INTEGER, INTENT(IN   ) :: LDEV
      INTEGER, INTENT(IN   ) :: DEV(*)
      REAL   , INTENT(  OUT) :: BHI(7,NY)
      INTEGER, INTENT(  OUT) :: IBHI(NY)
      INTEGER, INTENT(  OUT) :: IER
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: II,J,K,KL,KU,LBHI,M
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE PRECDEC
C-----------------------------------------------------------------------
      KL=IPAR(3)
      KU=IPAR(4)
      LBHI=IPAR(5)
C------ RESET THE BLOCKS BHI -----
c      BHI=0.0
c      DO J=1,NY
c         BHI(KL+KU+1,J)=1.0
c      ENDDO
      DO J=1,NY
         DO K=MAX(1,J-KU),MIN(NY,J+KL)
            BHI(KL+KU+1+K-J,J)=0.0
         ENDDO
         BHI(KL+KU+1,J)=1.0
      ENDDO
C------ DFY_m PART -----
      DO J=1,NY
         DO K=MAX(1,J-KU),MIN(NY,J+KL)
            II=KL+KU+1+K-J
            DO M=1,NM
c               BHI(II,J)=BHI(II,J)-H*GAMMA(I,M)*DFY(II-KL,J,M)
               BHI(II,J)=BHI(II,J)-H*GAMMA(I,M)*DFY(II-KL,J)
            ENDDO
         ENDDO
      ENDDO
      CALL DGBTRF(NY,NY,KL,KU,BHI,LBHI,IBHI,IER)
      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE PRECDEC
C-----------------------------------------------------------------------
