      SUBROUTINE COMPUTESCAL(NY,Y,RTOLY,ATOLY,ITOLY,SOLVEVN,ZYNS,ZNY,
     &                       SCALYINV)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NY
      REAL   , INTENT(IN   ) :: Y(NY)
      REAL   , INTENT(IN   ) :: RTOLY(*)
      REAL   , INTENT(IN   ) :: ATOLY(*)
      INTEGER, INTENT(IN   ) :: ITOLY
      LOGICAL, INTENT(IN   ) :: SOLVEVN
      REAL   , INTENT(IN   ) :: ZYNS(NY)
      REAL   , INTENT(IN   ) :: ZNY(NY)
      REAL   , INTENT(  OUT) :: SCALYINV(NY)
C    LOCAL VARIABLES
      INTEGER                :: I
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE COMPUTESCAL
C-----------------------------------------------------------------------
      IF (SOLVEVN) THEN
         IF (ITOLY==0) THEN
            DO I=1,NY
               SCALYINV(I)=1.0/(ATOLY(1)+RTOLY(1)*
     &                          MAX(ABS(Y(I)),ABS(Y(I)+ZNY( I))))
            ENDDO
         ELSE
            DO I=1,NY
               SCALYINV(I)=1.0/(ATOLY(I)+RTOLY(I)*
     &                          MAX(ABS(Y(I)),ABS(Y(I)+ZNY( I))))
            ENDDO
         ENDIF
      ELSE
         IF (ITOLY==0) THEN
            DO I=1,NY
               SCALYINV(I)=1.0/(ATOLY(1)+RTOLY(1)*
     &                          MAX(ABS(Y(I)),ABS(Y(I)+ZYNS(I))))
            ENDDO
         ELSE
            DO I=1,NY
               SCALYINV(I)=1.0/(ATOLY(I)+RTOLY(I)*
     &                          MAX(ABS(Y(I)),ABS(Y(I)+ZYNS(I))))
            ENDDO
         ENDIF
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE COMPUTESCAL
C-----------------------------------------------------------------------

