      SUBROUTINE INITSTEP(HNEWFACINV,THETA,HDEC,THETADNEWEVALEQ0,
     &                    T,TEND,POSNEG,NVGE1,ABSHMIN,ABSHMAX,
     &                    THETADNEWEVAL,THETAJNEWDEC,THET,
     &                    FNEWT,MINNEWT,MAXNEWT,ISTARTNEWT,SOLVEVN,H,
     &                    NSTEP,HNEW,ABSHNEW,CALJAC,CALJACVN,
     &                    DFYTOCOMPUTE,DEVTOCOMPUTE,
     &                    JACTOCOMPUTE,JACVNTOCOMPUTE)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      REAL   , INTENT(IN   ) :: HNEWFACINV
      REAL   , INTENT(IN   ) :: THETA
      REAL   , INTENT(IN   ) :: HDEC
      LOGICAL, INTENT(IN   ) :: THETADNEWEVALEQ0
      REAL   , INTENT(IN   ) :: T
      REAL   , INTENT(IN   ) :: TEND
      REAL   , INTENT(IN   ) :: POSNEG
      LOGICAL, INTENT(IN   ) :: NVGE1
      REAL   , INTENT(IN   ) :: ABSHMIN
      REAL   , INTENT(IN   ) :: ABSHMAX
      REAL   , INTENT(IN   ) :: THETADNEWEVAL
      REAL   , INTENT(IN   ) :: THETAJNEWDEC
      REAL   , INTENT(IN   ) :: THET
      REAL   , INTENT(IN   ) :: FNEWT
      INTEGER, INTENT(IN   ) :: MINNEWT
      INTEGER, INTENT(IN   ) :: MAXNEWT
      INTEGER, INTENT(IN   ) :: ISTARTNEWT
      LOGICAL, INTENT(IN   ) :: SOLVEVN
      REAL   , INTENT(  OUT) :: H
      INTEGER, INTENT(INOUT) :: NSTEP
      REAL   , INTENT(  OUT) :: HNEW
      REAL   , INTENT(  OUT) :: ABSHNEW
      LOGICAL, INTENT(  OUT) :: CALJAC
      LOGICAL, INTENT(  OUT) :: CALJACVN
      LOGICAL, INTENT(  OUT) :: DFYTOCOMPUTE
      LOGICAL, INTENT(  OUT) :: DEVTOCOMPUTE
      LOGICAL, INTENT(  OUT) :: JACTOCOMPUTE
      LOGICAL, INTENT(  OUT) :: JACVNTOCOMPUTE
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE INITSTEP
C-----------------------------------------------------------------------
      NSTEP=NSTEP+1
      HNEW=H/HNEWFACINV
      ABSHNEW=ABS(HNEW)
      IF     (ABSHNEW<ABSHMIN) THEN
         WRITE(6,*) ' WARNING: ABS(HNEW) =',ABSHNEW,
     &                      ' < RWORK(6) =',ABSHMIN
      ELSEIF (ABSHNEW>ABSHMAX) THEN
         WRITE(6,*) ' WARNING: ABS(HNEW) =',ABSHNEW,
     &                      ' > RWORK(7) =',ABSHMAX
      ENDIF
      H=POSNEG*MAX(ABSHMIN,MIN(ABSHNEW,ABSHMAX,ABS(TEND-T)))
      IF (ABS(TEND-(T+H))<ABSHMIN) H=TEND-T
      CALJAC  =.FALSE.
      CALJACVN=(.NOT.(SOLVEVN))
c      IF ((THETA>THETADNEWEVAL).OR.(THETADNEWEVALEQ0)) THEN
c      IF ((THETA-ABS(HOLD/HDEC-1.0)>THETADNEWEVAL).OR.
      IF ((THETA-ABS(   H/HDEC-1.0)>THETADNEWEVAL).OR.
     &    (THETADNEWEVALEQ0).OR.(NSTEP==1)) THEN
         DFYTOCOMPUTE=.TRUE.
         DEVTOCOMPUTE=(NVGE1)
      ELSE
         DFYTOCOMPUTE=.FALSE.
         DEVTOCOMPUTE=.FALSE.
         IF (ABS(H/HDEC-1.0)<=THETAJNEWDEC) THEN
            JACTOCOMPUTE  =.FALSE.
            JACVNTOCOMPUTE=.FALSE.
         ENDIF
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE INITSTEP
C-----------------------------------------------------------------------
