      SUBROUTINE INIT(T,NY,Y,RPAR,IPAR)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      REAL   , INTENT(INOUT) :: T
      INTEGER, INTENT(INOUT) :: NY
      REAL   , INTENT(INOUT) :: Y(NY)
      REAL   , INTENT(INOUT) :: RPAR(*)
      INTEGER, INTENT(INOUT) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: I,KL,KU,LBHI,N,N2
      REAL                   :: ANP1,ANP1INV,GAMMA,GAMMA2,PI,USDELQ,XI
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE INIT
C-----------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      N=500
      N2=2*N
      ANP1=REAL(N+1)
      ANP1INV=1.0/ANP1
      USDELQ=ANP1**2
      GAMMA=0.02*USDELQ
      GAMMA2=2.0*GAMMA
      RPAR(1)=GAMMA
      RPAR(2)=GAMMA2
      IPAR(1)=N
      IPAR(2)=N2
      KL=2
      KU=2
      LBHI=2*KL+KU+1
      IPAR(3)=KL
      IPAR(4)=KU
      IPAR(5)=LBHI
      T=0.0
      DO I=1,N
         XI=REAL(I)*ANP1INV
         Y(2*I  )=3.0
         Y(2*I-1)=1.0+0.5*SIN(2.0*PI*XI)
      ENDDO
      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE INIT
C-----------------------------------------------------------------------
