      SUBROUTINE PRECSOL(I,NY,NU,NV,BHI,IBHI,VEC,RPAR,IPAR)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: I
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL*8 , INTENT(IN   ) :: BHI(7,NY)
      INTEGER, INTENT(IN   ) :: IBHI(NY)
      REAL*8 , INTENT(INOUT) :: VEC(NY)
      REAL*8 , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: IER,KL,KU,LBHI
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE PRECSOL
C-----------------------------------------------------------------------
      KL=IPAR(3)
      KU=IPAR(4)
      LBHI=IPAR(5)
      CALL DGBTRS('N',NY,KL,KU,1,BHI,LBHI,IBHI,VEC,NY,IER)
      RETURN
      END
C-----------------------------------------------------------------------
C    END OF SUBROUTINE PRECSOL
C-----------------------------------------------------------------------
