      SUBROUTINE PRECDEC(I,NS,T,H,NY,NU,NV,Y,NM,GAMMA,
     &                   KDFYM,LDFYM,LDFY,DFY,LDEV,DEV,
     &                   BHI,IBHI,IER,RPAR,IPAR)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: I
      INTEGER, INTENT(IN   ) :: NS
      REAL   , INTENT(IN   ) :: T
      REAL   , INTENT(IN   ) :: H
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      INTEGER, INTENT(IN   ) :: NM
      REAL   , INTENT(IN   ) :: GAMMA(NS,NM)
      INTEGER, INTENT(IN   ) :: KDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFY
      REAL   , INTENT(IN   ) :: DFY(NY,NY)   ! DFY(NY,NY,NM)
      INTEGER, INTENT(IN   ) :: LDEV
      INTEGER, INTENT(IN   ) :: DEV(*)
      REAL   , INTENT(  OUT) :: BHI(NY,NY)
      INTEGER, INTENT(  OUT) :: IBHI(NY)
      INTEGER, INTENT(  OUT) :: IER
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: M
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE PRECDEC
C-----------------------------------------------------------------------
      M=1
      BHI(1,1)=1.0-H*GAMMA(I,M)*DFY(1,1)
      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE PRECDEC
C-----------------------------------------------------------------------
